# Copyright 1999-2007 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit eutils

DESCRIPTION="Frontend for dynamips"
HOMEPAGE="dyna-gen.sourceforge.net"
SRC_URI="mirror://sourceforge/dyna-gen/${P}.tar.gz"

LICENSE="GPL-2"
SLOT="0"
KEYWORDS="x86 amd64"
IUSE=""

DEPEND="dev-lang/python"



src_unpack() {
	unpack ${A}
	cd ${S}
}

src_install() {
	 dobin dynagen
	 insinto /usr/lib/python2.4/
	 doins *.py

	 insinto /usr/share/dynagen
	 doins configspec

	 insinto /etc/
	 doins dynagen.ini

	 dodoc README.txt sample_labs/*.txt sample_labs/*/* dynagen.ini
}

