#!/bin/sh


#we want to find free user to run simulation
COUNT=0;
SIM_USER_BASE="simu"
STARTUP_PATH="/opt/scripts/startup_user.sh"
START_PORT=$1
CONF_ID=$2
SIMU_DURATINON=$3
SHUTDOWN_PATH="/opt/scripts/shutdown.sh"


if [ -z "$1" -o -z "$2" -o -z "$3" ];then
	echo "Usage START_PORT CONF_ID SIMU_DURATINON"
	exit 8;
fi

if [ -n "`netstat -l -n|grep $START_PORT`" ];then
	echo "Port in use !!!"
	exit 3;
fi

for i in `cat /etc/passwd | grep $SIM_USER_BASE|awk -F":" '{print $1}' `; do
	if [ -z "`ps -u $i | grep -w 'dynamips'`"  ] ; then
		RUN_USER="$i"
		break;
	fi;	
done
echo "STRATUP: Running sudo -u $RUN_USER $STARTUP_PATH $START_PORT $CONF_ID "

/usr/bin/sudo -H -u "$RUN_USER" $STARTUP_PATH $START_PORT $CONF_ID 

if [ "$?" -ne 0 ];then
	/usr/bin/sudo $SHUTDOWN_PATH 0 $RUN_USER
	exit $?
fi;
echo "STRATUP:Running sudo $SHUTDOWN_PATH $SIMU_DURATINON $RUN_USER " 

/usr/bin/sudo $SHUTDOWN_PATH $SIMU_DURATINON $RUN_USER &
exit $?

