<?

class database extends debug
{
	var $error_message = "";
	private $link;
	private $etc;
	private $result;

	function database() /* {{{ */
	{
		// load configuration
		include_once('./etc/db.etc.php');
		$this->etc = $etc['db'];

		$this->result = null;

	} /* }}} */

	function connect() /* {{{ */
	{
		// try to connect to database
		$this->debug("connecting to database server ", $this->etc['server'] . " as " . $this->etc['user']);
		$this->link = @mysql_connect(
				$this->etc['server'],
				$this->etc['user'],
				$this->etc['password']);
				
		// if connection was not successfull
		if (!$this->link)
		{
			$this->error_message = mysql_error($this->link);
			$this->error("unable to connect to database", $this->error_message);
			return false;
		}
		
		// try to select database
		$this->debug("selecting database", $this->etc['dbname']);
		if (!@mysql_select_db($this->etc['dbname'], $this->link))
		{
			// if the select was unsuccessfull
			$this->error_message = mysql_error($this->link);
			$this->error("unable to select database", $this->error_message);
			return false;
		}	

		mysql_query("SET character set utf8");
		mysql_query("SET character_set_results=utf8");
		mysql_query("SET character_set_connection=utf8");

		return true;

	} /* }}} */
	
	private function parse_query($query = "", $arguments = "") /* {{{ */
	{
		// check inputs
		if (!is_array($arguments))
			return $query;
			
		foreach ($arguments as $key => $value)
		{
			$value = mysql_real_escape_string($value);
			$query = str_replace('?' . $key, $value, $query);
		}
		return $query;

	} /* }}} */
	
	function query($query = "", $attributes = null) /* {{{ */
	{
		$this->error_message = "";

		// parse query with variables
		$query = $this->parse_query($query, $attributes);
		
		$this->debug("query", $query);
		
		// send query to server
		$result = mysql_query($query);
		
		// check if data were obtained
		if (!$result)
		{
			$this->error_message = mysql_error();
			$this->error("error in query", $this->error_message);
		}

		$this->result = $result;
		return $result;

	} /* }}} */
	
	function num_rows($result = null) /* {{{ */
	{
		if ($result == null)
			return mysql_num_rows($this->result);

		return mysql_num_rows($result);		

	} /* }}} */

	function fetch($result = null) /* {{{ */
	{
		if ($result == null)
			return mysql_fetch_assoc($this->result);

		return mysql_fetch_assoc($result);

	} /* }}} */
	
	function get_records($query = "", $attributes = null) /* {{{ */
	{
		$records = array();

		// if query was unsuccessfull return empty array
		if (!$this->query($query, $attributes))
		{
			return $records;
		}

		while ($row = $this->fetch())
		{
			$records[] = $row;
		}

		return $records;

	} /* }}} */
	
	function get_record($query = "", $attributes = null) /* {{{ */
	{
		// if query was unsuccessfull return empty array
		if (!$this->query($query, $attributes))
			return null;

		return $this->fetch();

	} /* }}} */
	
	function affected_rows($link = null) /* {{{ */
	{
		if($link == null)
			return mysql_affected_rows($this->link);

		return mysql_affected_rows($link);

	} /* }}} */
	
	function insert_id() /* {{{ */
	{
		return mysql_insert_id();

	} /* }}} */

	function escape($text) /* {{{ */
	{
		return mysql_real_escape_string($text);

	} /* }}} */
	
	function close($link = null) /* {{{ */
	{
		if ($link == null)
			return mysql_close($this->link);

		return mysql_close($link);

	} /* }}} */

	function set_db_link($db_link = null) /* {{{ */
	{
		if ($db_link == null)
			$this->error("invalid database link");

		$this->link = $db_link;

	} /* }}} */

}

?>
