<?

include_once("./dao/login.dao.php");

class login extends module
{

	private $success = 0;
	private $login_dao;

	function login($db_link) /* {{{ */
	{
		$this->module();

		$this->debug("session variable", $_SESSION);

		$this->login_dao = new login_dao($db_link);

		$this->success = 0;
		$this->login_process();

	} /* }}} */

	function login_process() /* {{{ */
	{
		if (isset($_SESSION['logged']) AND $_SESSION['logged'])
		{
			if($this->check_session())
			{
				// user is logged
			//	$this->set_logged_info();
			//	$this->parse("logged.tpl.php");
				$this->debug("user is already logged in");
			} else
			{
				// user is not logged
				$this->parse("login.tpl.php");
				$this->debug("user is already logged out");
			}

		} elseif(isset($this->post['login_submit']))
		{
			$record = $this->login_dao->get_user_by_username_password($this->post['username'], sha1($this->post['password']));
			if ($this->login_dao->num_rows() == 1)
			{
				$_SESSION['id'] = $record['id'];
				$_SESSION['username'] = $this->login_dao->escape($record['username']);
				$_SESSION['logged'] = true;
				$_SESSION['group'] = $this->login_dao->escape($record['group']);

				$this->login_dao->set_session_ip_timestamp_by_id(session_id(), $_SERVER['REMOTE_ADDR'], time(), $record['id']);

				$this->success = 1;

			//	$this->set_logged_info();
			//	$this->parse("logged.tpl.php");
				$this->debug("user is successfuly logged in");

				$this->redirect("index.php?mod=page&act=info");
			}
			else
			{
				$this->session_defaults();
				$this->success = 0;

				$this->tpl_array['LOGIN_ERROR'] = "[ Invalid password ]";
				$this->parse("login.tpl.php");
				$this->debug("invalid password");
			}
		}
		else
		{
			$this->session_defaults();
			$this->success = 0;

		//	$this->redirect("index.php?mod=login");	

			$this->parse("login.tpl.php");
			$this->debug("user is not logged");
		}

	} /* }}} */

	function check_session() /* {{{ */
	{
		$record = $this->login_dao->get_user_by_username_session_ip($_SESSION['username'], session_id(), $_SERVER['REMOTE_ADDR']);
		if ($this->login_dao->num_rows() == 1)
		{
			$_SESSION['id'] = $record['id'];
			$_SESSION['username'] = $this->login_dao->escape($record['username']);
			$_SESSION['logged'] = true;
			$_SESSION['group'] = $this->login_dao->escape($record['group']);

			$this->login_dao->set_session_ip_timestamp_by_id(session_id(), $_SERVER['REMOTE_ADDR'], time(), $record['id']);
			$this->success = 1;

			return true;
		} else
		{
			$this->session_defaults();
			$this->success = 0;

			return false;
		}

	} /* }}} */

	function session_defaults() /* {{{ */
	{
		$_SESSION['id'] = 0;
		$_SESSION['username'] = "";
		$_SESSION['logged'] = false;
		$_SESSION['group'] = "";

		$this->success = 0;

		session_unregister("id");
		session_unregister("username");
		session_unregister("logged");
		session_unregister("group");

	} /* }}} */

	function is_logged() /* {{{ */
	{
		return $this->success;

	} /* }}} */

}

?>
