# Copyright 1999-2007 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit eutils

MY_PR="RC5"
MY_P=${PN}-${PV}-${MY_PR}

S=${WORKDIR}/${MY_P}

#MY_P="${P/_/}"
#S="${WORKDIR}/${MY_P}"

DESCRIPTION="Simulator of Cisco 3600 and 7200"
HOMEPAGE="http://www.ipflow.utc.fr/index.php/Cisco_7200_Simulator"
SRC_URI="http://www.ipflow.utc.fr/dynamips/${MY_P}.tar.gz"

LICENSE="GPL-2"
SLOT="0"
KEYWORDS="x86 amd64"
IUSE=""

DEPEND="net-libs/libpcap
		dev-libs/libelf"



src_unpack() {
	unpack ${A}
	cd ${S}
	epatch ${FILESDIR}/${ARCH}_libpcap.patch
}

src_compile() {
	emake || die
}

src_install() {
	 dobin dynamips nvram_export
     doman dynamips.1 hypervisor_mode.7 nvram_export.1  
	 dodoc COPYING ChangeLog TODO README README.hypervisor 

	newinitd "${FILESDIR}"/dynamips-initd dynamips
	 newconfd "${FILESDIR}"/dynamips-confd dynamips	
}

