#CC=checkergcc
CC = gcc

WALL =  -Wall -Wstrict-prototypes -Wmissing-prototypes -Wpointer-arith -Wno-sign-compare -Wno-traditional -Wreturn-type -Wswitch -Wshadow -Wcast-qual -Wwrite-strings -Wextra -Wno-unused-parameter  -Werror

CFLAGS = -O2 -pipe -g3 -D__USEMISC

LDFLAGS = -pthread -lresolv

all:	prx 

proxy: proxy.c
	${CC} ${CFLAGS} ${WALL} -c proxy.c

proxy_auth: proxy_auth.c
	${CC} ${CFLAGS} ${WALL} -c proxy_auth.c

proxy_client: proxy_client.c
	${CC} ${CFLAGS} ${WALL} -c proxy_client.c

prx: proxy proxy_auth proxy_client
	${CC} ${CFLAGS} ${LDFLAGS} ${WALL} proxy.o proxy_auth.o proxy_client.o -o proxy

clean:
	rm -f *.o proxy

