<?

include_once("HTML/QuickForm2.php");

class form extends common_module
{

	var $qform;

	function form($id, $method = 'post', $attributes = null, $trackSubmit = true) /* {{{ */
	{
		$this->common_module();

		$this->qform = new HTML_QuickForm2($id, $method, $attributes, $trackSubmit);

	} /* }}} */

	function form_validate() /* {{{ */
	{
		if ($this->qform->validate())
		{
			$this->debug("process values", $this->qform->getValue());
			return $this->qform->getValue();
		}

		return false;

	} /* }}} */

	function get_html() /* {{{ */
	{
/*
		$return_html = "";

		$return_html = "<form" . $form->getAttributes(true) . ">";
		foreach ($form as $element)
		{
			$return_html .= $this->output_element($element);
		}
		$return_html .= "</form>";

		return $return_html;
*/

		$this->tpl_array['form']['attr'] = $this->qform->getAttributes(true);
		foreach ($this->qform as $element)
		{
			$this->tpl_array['form']['elements'][] = $this->output_element($element);
		}

//		$this->debug("parameters", $this->tpl_array['form']);

		$this->parse("form.tpl.php");
		return $this->code;

	} /* }}} */

	function output_fieldset($fieldset) /* {{{ */
	{
/*
		$return_html = "";

		$return_html .= '<fieldset' . $fieldset->getAttributes(true) . ">\n<legend>" .
			$fieldset->getLabel() . "</legend>\n";
		foreach ($fieldset as $element) {
			$return_html .= $this->output_element($element);
		}
		$return_html .=  "</fieldset>\n";

		return $return_html;
*/

		$fieldset_param['attr'] = $fieldset->getAttributes(true);
		$fieldset_param['label'] = $fieldset->getLabel(); 
		foreach ($fieldset as $element) {
			$fieldset_param['elements'][] = $this->output_element($element);
		}

		return $fieldset_param;

	} /* }}} */

	function output_element($element) /* {{{ */
	{
/*
		$return_html = "";

		if ('fieldset' == $element->getType()) {
			$return_html .= $this->output_fieldset($element);
		} elseif ('hidden' == $element->getType()) {
			$return_html .= '<div style="display: none;">' . $element->__toString() . "</div>\n";
		} else {
			$required = $element->isRequired();
			$error    = $element->getError();
			$return_html .= '<div class="qfrow"><label class="qflabel" for="' . $element->getId() .
				'">' . ($required? '<span class="required">*</span>': '') . $element->getLabel() .
				'</label> <div class="qfelement' . (strlen($error)? ' error': '') . '">' .
				(strlen($error)? '<span class="error">' . $error . '</span><br />': '') .
				$element->__toString() . "</div></div><br />\n";
		}

		return $return_html;
*/

		$element_param['type'] = $element->getType();

		if ($element->getType() == "fieldset")
		{
			$element_param['sub_elements'] = $this->output_fieldset($element);

		} elseif ($element->getType() == "hidden")
		{
			$element_param['to_string'] = $element->__toString();
		} else
		{
			$element_param['id'] = $element->getId();
			$element_param['label'] = $element->getLabel();
			$element_param['required'] = $element->isRequired();
			$element_param['error'] = $element->getError();
			$element_param['to_string'] = $element->__toString();
		}

		return $element_param;

	} /* }}} */

	function store_uploaded_file($uploaded_file, $dst_dir) /* {{{ */
	{
		if (file_exists($dst_dir))
		{
			$dst_path = $dst_dir . "/" . md5(rand()) . "_" . $uploaded_file['name'];

			if (move_uploaded_file($uploaded_file['tmp_name'], $dst_path))
			{
				$this->debug("file was successfully uploaded", $dst_path);
				return $dst_path;
			} else
			{
				$this->error("possible file upload attack", $uploaded_file['tmp_name']);
				return "";
			}
		} else
		{
			$this->error("destination directory doesn't exists", $dst_dir);
			return "";
		}

	} /* }}} */

}

?>
