<?

class parser extends debug
{
	var $compile_dir = "";
	var $template_dir = "";
	var $config_dir = "";
	var $smarty;

	function parser() /* {{{ */
	{
		if (!class_exists("Smarty"))
			include("smarty/Smarty.class.php");
		$this->smarty = new Smarty();

	} /* }}} */

	function set_template_dir($dir = "") /* {{{ */
	{
		$this->template_dir = $dir;

	} /* }}} */

	function set_compile_dir($dir = "") /* {{{ */
	{
		$this->compile_dir = $dir;

	} /* }}} */

	function set_config_dir($dir = "") /* {{{ */
	{
		$this->config_dir = $dir;

	} /* }}} */

	function parse_code($tpl_name = "", $tpl_array = array()) /* {{{ */
	{
		$this->debug("parsing template", $this->template_dir . $tpl_name);

		$this->smarty->template_dir = $this->template_dir;
		$this->smarty->compile_dir = $this->compile_dir;
		$this->smarty->config_dir = $this->config_dir;

		if (isset($tpl_array))
		{
			foreach($tpl_array as $key => $value)
			{
				$this->smarty->assign($key, $value);
			}
		}

		return $this->smarty->fetch($tpl_name);

	} /* }}} */

}

?>
