<?

include_once("./lib/debug.class.php");
include_once("./lib/module.class.php");
include_once("./lib/database.class.php");
include_once("./lib/form.class.php");

class system extends module
{

	var $db;

	function system() /* {{{ */
	{
		$this->module();

		// database connect
		$this->db = new database();
		$this->db->connect();

		$this->system_login();

		$this->system_menu();

		$this->debug("requested module", $this->get['mod']);

		$module = $this->insert_module($this->get['mod']);
		if ($module != false)
		{
			$this->tpl_array['MODUL'] = $module->code;
		}

		if ($this->is_logged())
		{
			$this->system_set_logged_info();
		}
		$this->parse("system.tpl.php");
		print $this->code;

		// database disconnect
		$this->db->close();

	} /* }}} */

	function insert_module($module_class = "") /* {{{ */
	{
		/* create object of class acoording to $module */
		if (! class_exists($module_class))
		{
		//	include("./modules/" . $module_class . "/" . $module_class . ".class.php");

			if (file_exists("./modules/" . $module_class . ".class.php"))
			{
				include("./modules/" . $module_class . ".class.php");
			}
		}

		if (class_exists($module_class))
		{
			$module = new $module_class($this->db);
			return $module;
		} else
		{
			$this->debug("undefined class", $module_class);
		}

		return false;

	} /* }}} */

	function system_login() /* {{{ */
	{
		if (! $this->is_logged())
		{
			$this->get['mod'] = "login";

		} elseif ($this->is_logged() AND ! isset($this->get['mod']))
		{
			$this->get['mod'] = "page";
			$this->get['act'] = "info";		
		}

		$login = $this->insert_module("login");

	} /* }}} */

	function system_set_logged_info() /* {{{ */
	{
		$this->tpl_array['LOGGED'] = true;
		$this->tpl_array['LOGGED_USER'] = $_SESSION['username'];
		$this->tpl_array['CURRENT_TIME'] = date("D  d.m.Y  H:i:s");

	} /* }}} */

	function system_menu() /* {{{ */
	{
//		if (isset($_SESSION['logged']) AND $_SESSION['logged'])
		if ($this->is_logged())
		{
			$menu = $this->insert_module("menu");
			$menu->menu_modules();
			$this->tpl_array['MENU'] = $menu->code;
		}

	} /* }}} */

} 

?>
