{ defun name="output_fieldset" }
	{ if $fieldset }
		<fieldset { $fieldset.attr } >
			<legend> { $fieldset.label } </legend>
			{ foreach from=$fieldset.elements item=element }
				{ fun name="output_element" element=$element }
			{ /foreach }
		</fieldset>
	{ /if }
{ /defun }

{ defun name="output_element" }
	{ if $element }
		{ if $element.type == "fieldset" }
			{ fun name="output_fieldset" fieldset=$element.sub_elements }
		{ elseif $element.type == "hidden" }
			<div style="display: none;"> { $element.to_string } </div>
		{ else }
			<div class="qfrow">
				<label class="qflabel" for="{ $element.id }">
					{ if $element.required } <span class="required">*</span> { /if }
					{ $element.label }
				</label>
				<div class="qfelement{ if $element.error } error{ /if }">
					{ $element.to_string }
					{ if $element.error } <span class="error"> &nbsp; &nbsp; { $element.error } </span><br /> { /if }
				</div>
			</div><br />
		{ /if }
	{ /if }
{ /defun }

<form { $form.attr } >

{ foreach from=$form.elements item=element }
	{ fun name="output_element" element=$element }
{ /foreach }

</form>

